#
#  TOPPERS ATK2
#      Toyohashi Open Platform for Embedded Real-Time Systems
#      Automotive Kernel Version 2
#
#  Copyright (C) 2008-2013 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
#  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
#  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
#  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
#  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
#  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
#  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
#  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: Makefile.prc 7069 2013-02-22 07:43:11Z shigihara $
#

#
#		Makefile Υץå¸Nios2ѡ
#

#
#  ץå̾ȯĶ̾
#
PRC  = nios2
TOOL = gcc

#
#  ץå¸ǥ쥯ȥ̾
#
PRCDIR = $(SRCDIR)/arch/$(PRC)_$(TOOL)

#
#  ֤32Хȥ饤
#
ifeq ($(ALIGN_FUNCTIONS_32), true)
	CDEFS := $(CDEFS) -DFUNCTION_ALIGN_SIZE=32
	COPTS := $(COPTS) -falign-functions=32
endif

#
#  ѥ륪ץ
#
INCLUDES := $(INCLUDES) -I$(PRCDIR) -I$(SRCDIR)/arch/$(TOOL)
COPTS := $(COPTS) -fno-common
LIBS := $(LIBS) -lgcc -lc

#
#  C++testѻ˥󥯤饤֥
#  (initialize_sectionsؤΥդ򤹤)
#
ifdef USE_CPPTEST
  COPTS := $(COPTS) -DOMIT_INITIALIZE_SECTIONS
  LIBS := $(LIBS) $(KERNEL_LIB)/libcpptest.a -lgcc
endif

#
#  ͥ˴ؤ
#
KERNEL_DIR := $(KERNEL_DIR) $(PRCDIR)
KERNEL_ASMOBJS := $(KERNEL_ASMOBJS) prc_support.o
KERNEL_COBJS := $(KERNEL_COBJS) prc_config.o avalon_timer.o vic.o prc_mpu.o

#
#  GNUȯĶΥåȥƥ
#
GCC_TARGET = nios2-elf

#
#  ȥåץ⥸塼˴ؤ
#
#  START_OBJSstart.oꤷLDFLAGS-nostdlibɲä롥
#
START_OBJS = start.o

$(START_OBJS): %.o: %.S
	$(CC) -c $(CFLAGS) $(KERNEL_CFLAGS) $<

$(START_OBJS:.o=.d): %.d: %.S
	@$(PERL) $(SRCDIR)/utils/makedep -C $(CC) \
		-O "$(CFLAGS) $(KERNEL_CFLAGS)" $< >> Makefile.depend

#
#  󥫥ץȤ
#
LDSCRIPT = ldscript.ld
CFG2_OUT_LDSCRIPT := cfg2_out.ld
CFG3_OUT_LDSCRIPT := cfg3_out.ld
CLEAN_FILES := $(CLEAN_FILES) $(CFG2_OUT_LDSCRIPT) $(CFG3_OUT_LDSCRIPT) $(LDSCRIPT)


LDFLAGS          := -nostdlib $(LDFLAGS)
CFG1_OUT_LDFLAGS := -nostdlib $(CFG1_OUT_LDFLAGS)
CFG2_OUT_LDFLAGS := -nostdlib $(CFG2_OUT_LDFLAGS)
CFG3_OUT_LDFLAGS := -nostdlib $(CFG3_OUT_LDFLAGS)

#
#  ¸ط
#
cfg1_out.c: $(PRCDIR)/prc_def.csv
Os_Lcfg.timestamp: $(PRCDIR)/prc.tf $(PRCDIR)/prc_common.tf
kernel_mem3.c: $(PRCDIR)/prc_mem.tf
kernel_mem.c: $(PRCDIR)/prc_mem2.tf $(PRCDIR)/prc_check.tf
offset.h: $(PRCDIR)/prc_offset.tf

#
#  ե졼طѿ
#
CFG_TABS := $(CFG_TABS) --cfg1-def-table $(PRCDIR)/prc_def.csv
